
// STARTOVNI CISLO 28

#include "config.h"
#include "MainWindow.hh"
#include <iostream>
#include <fstream>
#include <cassert>
#include "FIleSaveDlg.hh"

using namespace std;

MainWindow::MainWindow()
	: m_bPlaying(false)
{
	//Glib::signal_timeout().connect(sigc::mem_fun(*this, &MainWindow::on_timeout), 1000);
	//assert(display->get_window());
}

void MainWindow::on_btnLoad_clicked()
{
	Gtk::FileSelection dlg;
	dlg.add_button("OK", Gtk::RESPONSE_OK);
	dlg.add_button("Cancel", Gtk::RESPONSE_CANCEL);

	if(dlg.run() == Gtk::RESPONSE_OK)
	{
		std::string name = dlg.get_filename();
		m_mapa.Load(name.c_str());
		m_mapa.ComputeRoute();
		
		display->get_window()->invalidate_rect(Gdk::Rectangle(0,0,1024,1024), false);
	}
}

bool MainWindow::on_display_expose_event(GdkEventExpose *ev)
{
	std::cout << "expose_event!\n";
	
	//std::vector<Gdk::Rectangle> rects = Gdk::Region(ev->region).get_rectangles();
	Gdk::Color color;
	Gdk::Color clrGrey, clrYellow, clrBlue, clrRed, clrGreen;
	Glib::RefPtr<Gdk::GC> gc;
	Glib::RefPtr<Gdk::Window> window = display->get_window();
	Glib::RefPtr<Gdk::Colormap> colormap;
	std::vector<char*> data;
	
	gc = Gdk::GC::create(window);
	colormap = gc->get_colormap();
	
	color.set_grey(0);
	clrGrey.set_grey(0x7777);
	clrYellow.set_rgb(0xffff,0xffff,0);
	clrBlue.set_rgb(0,0,0xffff);
	clrRed.set_rgb(0xffff,0,0);
	clrGreen.set_rgb(0,0xffff,0);
	
	colormap->alloc_color(clrGrey);
	colormap->alloc_color(clrYellow);
	colormap->alloc_color(clrBlue);
	colormap->alloc_color(clrRed);
	colormap->alloc_color(clrGreen);
	
	gc->set_foreground(color);
	window->draw_rectangle(gc, true, 0, 0, m_mapa.GetX()*4, m_mapa.GetY()*4);
	
	cout << "X: " << m_mapa.GetX() << "; Y: " << m_mapa.GetY() << endl;
	
	//for(int i=0;i<rects.size();i++)
	//{
	for(int x=/*rects[i].get_x()*/0;x<m_mapa.GetX() /*&& x<rects[i].get_x()+rects[i].get_width()*/;x++)
		{
			for(int y=/*rects[i].get_y()*/0;y<m_mapa.GetY() /*&& y<rects[i].get_y()+rects[i].get_height()*/;y++)
			{
				char c = m_mapa.GetPt(x,y);
				//cout << c;
				switch(c)
				{
				case '.':
					color = clrGrey; break;
				case ':':
					color = clrYellow; break;
				case 'S':
					color = clrRed; break;
				case 'C':
					color = clrBlue; break;
				default:
					continue;
				}
				
				gc->set_foreground(color);
				window->draw_rectangle(gc, true, x*4, y*4, 4, 4);
			}
			cout << endl;
		}
	//}
	
	int sx=0,sy=0;
	int px=m_mapa.m_start_x,py=m_mapa.m_start_y;
	
	gc->set_foreground(clrGreen);
	
	for(size_t i=0;i<m_mapa.m_speeds.size();i++)
	{
		sx += m_mapa.m_speeds[i].first;
		sy += m_mapa.m_speeds[i].second;
		
		px += sx;
		py += sy;
		
		window->draw_rectangle(gc, true, px*4, py*4, 4, 4);
	}
	
	return false;
}

void MainWindow::on_btnPlay_clicked()
{
	m_bPlaying = true;
}

bool MainWindow::on_timeout()
{
	return true;
}

void MainWindow::on_btnSave_clicked()
{
	FIleSaveDlg dlg;
	if(dlg.run() == Gtk::RESPONSE_OK)
	{
		Glib::ustring path = dlg.entryFile->get_text();
		ofstream vystup(path.c_str());
		for(size_t i=0;i<m_mapa.m_speeds.size();i++)
		{
			vystup << m_mapa.m_speeds[i].first << ',' << -m_mapa.m_speeds[i].second << endl;
		}
	}
}

