#include "mapa.h"
#include <fstream>
#include <stdexcept>
#include <iostream>

using namespace std;

Mapa::Mapa()
	: m_x(0)
{
}

Mapa::~Mapa()
{
	Destroy();
}

void Mapa::Destroy()
{
	for(size_t i=0;i<m_data.size();i++)
		delete [] m_data[i];
	m_data.clear();
	m_speeds.clear();
	m_x = 0;
}

void Mapa::Load(const char* file)
{
	//std::ifstream f;
	//f.open(file);
	FILE* f = fopen(file,"r");
	char* line;
	
	if(!f)
		throw std::runtime_error("Cannot open specified file");
	
	Destroy();
	
	line = new char[300];
	
	int c = 0;
	
	while(!feof(f))
	{
		fgets(line,300,f);
		if(m_x == 0)
			m_x = strlen(line);
		cout << "Line len: " << m_x << endl;
		
		std::cout << std::string(line,m_x) << std::endl;
		
		//if(line[0] == 0)
		//	break;
		//{
		//	cout << "Breaking on " << line << endl;
		//	break;
		//}
		
		char* nbuf = new char[m_x];
		memcpy(nbuf, line, m_x);
		m_data.push_back(nbuf);
		
		cout << "Line no" << c++ << endl;
	}
	fclose(f);
	
	delete [] line;
}

void Mapa::ComputeRoute()
{
	// najit start
	int sx=0,sy=0;
	int px=0,py=0; // aktualni misto
	std::vector<std::pair<int,int> > points, points_s;
	std::vector<std::pair<int,int> >& speeds = m_speeds;
	std::vector<std::pair<int,int> > targets;
	
	for(size_t i=0;i<m_data.size() && sx == 0;i++)
	{
		for(size_t j=0;j<GetX();j++)
		{
			if(m_data[i][j] == 'S')
			{
				cout << "Found S at [" << j << "," << i << "]\n";
				sy = i;
				sx = j;
				//cin.get();
				break;
			}
		}
	}
	
	for(size_t i=0;i<m_data.size();i++)
	{
		for(size_t j=0;j<GetX();j++)
		{
			if(m_data[i][j] == 'C')
			{
				targets.push_back(std::make_pair(j,i));
			}
		}
	}
	
	for(size_t i=0;i<m_data.size();i++)
	{
		for(size_t j=0;j<GetX();j++)
		{
			if(m_data[i][j] == ':')
			{
				points.push_back(std::make_pair<int,int>(j,i));
			}
		}
	}

	m_start_x = px = sx;
	m_start_y = py = sy;
	bool reached = false;
	
	// najit nejblizsi dalsi ':'
	while(!reached)
	{
		//cout << "Searching for [" << px << "," << py << "]\n";
		//cout << points.size() << " remaining\n";
			
		for(size_t i=0;i<points.size();i++)
		{
			if(abs(points[i].first-px) <= 1 && abs(points[i].second-py) <= 1)
			{
				points_s.push_back(points[i]);
				px = points[i].first;
				py = points[i].second;
				points.erase(points.begin()+i); // seradit je do trasy
			}
		}
		
		for(size_t i=0;i<targets.size();i++)
		{
			if(abs(targets[i].first-px) <= 1 && abs(targets[i].second-py) <= 1)
			{
				points_s.push_back(targets[i]);
				cout << "TG is " << targets[i].first << ',' << targets[i].second << endl;
				reached = true;
				break;
			}
		}
	}
	
	//points_s.push_back(points[0]);
	
	cout << "Sorted data, " << points_s.size() << "elems\n";
	
	int spx=0,spy=0; // rychlosti
	px = sx;
	py = sy;
	
	for(size_t i=0;i<points_s.size();i++)
	{
		//cout << "Prev pos is [" << px << "," << py << "]\n";
		//cout << "Pos is [" << points_s[i].first << "," << points_s[i].second << "]\n";
		int dx = points_s[i].first - px;
		int dy = points_s[i].second - py;
		
		//cout << "Direction is [" << dx << "," << dy << "]\n";
		
		int nsx = dx-spx;
		int nsy = dy-spy;
		
		//cout << "Change is [" << nsx << "," << nsy << "]\n";
		
		if(abs(nsx) > 1) // musime zmenit smer predchozich (zpomalit)
		{
			for(size_t j=speeds.size(); abs(nsx) > 1 && j>0;j--)
			{
				if(nsx < 0)
				{
					if(speeds[j-1].first > -1)
					{
						//cout << "\tSlowing 1 at " << j-1 << "\n";
						speeds[j-1].first--;
						nsx++;
					}
				}
				else
				{
					if(speeds[j-1].first < 1)
					{
						//cout << "\tSlowing 2 at " << j-1 << "\n";
						speeds[j-1].first++;
						nsx--;
					}
				}
			}
		}
		if(abs(nsy) > 1)
		{
			for(size_t j=speeds.size();abs(nsy) > 1 && j>0;j--)
			{
				//cout << "testing " << j-1 << endl;
				if(nsy < 0)
				{
					if(speeds[j-1].second > -1)
					{
						//cout << "\tSlowing 3 at " << j-1 << "\n";
						speeds[j-1].second--;
						nsy++;
					}
				}
				else
				{
					if(speeds[j-1].second < 1)
					{
						//cout << "\tSlowing 4 at " << j-1 << "\n";
						speeds[j-1].second++;
						nsy--;
					}
				}
			}
		}
		
		/*
		// zkusime zrychlit
		if(abs(nsx) < 1)
		{
			if(dx > 0)
				nsx ++;
			else
				nsx--;
		}
		if(abs(nsy) < 1)
		{
			if(dy > 0)
				nsy ++;
			else
				nsy--;
		}
		*/
		
		//cout << "Writing [" << nsx << "," << nsy << "]\n";
		
		speeds.push_back(std::make_pair(nsx,nsy));
		
		spx = spy = 0;
		for(size_t j=0;j<speeds.size();j++)
		{
			spx += speeds[j].first;
			spy += speeds[j].second;
		}
		
		px += spx;
		py += spy;
		
		//cout << "PT is done\n";
	}
}

char Mapa::GetPt(int x, int y)
{
	//return 'X';
	if(x < 0 || y < 0 || x >= GetX() || y >= GetY())
		return 'X';
	else
		return m_data[y][x];
}
